"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTransferNativeTokensWithRelayInstruction = void 0;
const web3_js_1 = require("@solana/web3.js");
const cpi_js_1 = require("../../tokenBridge/cpi.js");
const program_js_1 = require("../program.js");
const index_js_1 = require("./../accounts/index.js");
const spl_token_1 = require("@solana/spl-token");
const signerSequence_js_1 = require("../accounts/signerSequence.js");
const sdk_connect_1 = require("@wormhole-foundation/sdk-connect");
const anchor = __importStar(require("@project-serum/anchor"));
const { BN } = anchor;
async function createTransferNativeTokensWithRelayInstruction(connection, programId, payer, tokenBridgeProgramId, wormholeProgramId, mint, amount, toNativeTokenAmount, recipientAddress, recipientChain, batchId, wrapNative) {
    const { methods: { transferNativeTokensWithRelay }, account: { signerSequence }, } = (0, program_js_1.createTokenBridgeRelayerProgramInterface)(programId, connection);
    const signerSequenceAddress = (0, signerSequence_js_1.deriveSignerSequenceAddress)(programId, payer);
    const sequence = await signerSequence
        .fetch(signerSequenceAddress)
        .then(({ value }) => value)
        .catch((e) => {
        if (e.message?.includes('Account does not exist')) {
            // first time transferring
            return new BN(0);
        }
        throw e;
    });
    const message = (0, index_js_1.deriveTokenTransferMessageAddress)(programId, payer, sequence);
    const fromTokenAccount = (0, spl_token_1.getAssociatedTokenAddressSync)(new web3_js_1.PublicKey(mint), new web3_js_1.PublicKey(payer));
    const tmpTokenAccount = (0, index_js_1.deriveTmpTokenAccountAddress)(programId, mint);
    const tokenBridgeAccounts = (0, cpi_js_1.getTransferNativeWithPayloadCpiAccounts)(programId, tokenBridgeProgramId, wormholeProgramId, payer, message, fromTokenAccount, mint);
    return transferNativeTokensWithRelay(new BN(amount.toString()), new BN(toNativeTokenAmount.toString()), (0, sdk_connect_1.toChainId)(recipientChain), [...recipientAddress], batchId, wrapNative)
        .accounts({
        config: (0, index_js_1.deriveSenderConfigAddress)(programId),
        payerSequence: signerSequenceAddress,
        foreignContract: (0, index_js_1.deriveForeignContractAddress)(programId, recipientChain),
        registeredToken: (0, index_js_1.deriveRegisteredTokenAddress)(programId, mint),
        tmpTokenAccount,
        tokenBridgeProgram: new web3_js_1.PublicKey(tokenBridgeProgramId),
        ...tokenBridgeAccounts,
    })
        .instruction();
}
exports.createTransferNativeTokensWithRelayInstruction = createTransferNativeTokensWithRelayInstruction;
//# sourceMappingURL=transferNativeTokensWithRelay.js.map